﻿using System;
using System.Collections;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace Nerv35
{
    public class Stub_command
    {
        // nerv_stub_command delegate
        public delegate void on_sync_ft(IntPtr _command_, Address _proxy_addr, Sync_model _sync_model, Double _elapsed_time, Double _limit, IntPtr _cmd_data_, UInt32 _cmd_size);

        public delegate Int32 on_link_ft(IntPtr _command_, Address _proxy_addr, Double _packet_live_time, Double _packet_limit_time);

        public delegate void on_unlink_ft(IntPtr _object_, Address _proxy_addr, Int32 _err);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_command_alloc")]
        public static extern IntPtr alloc(UInt16 _code, IntPtr _object, on_sync_ft _on_command_sync_, on_link_ft _on_link_, on_unlink_ft _on_unlink_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_command_free")]
        public static extern void free(IntPtr _command_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_command_unlink")]
        public static extern void unlink(IntPtr _command_, Address _proxy_addr);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_command_unlink_all_proxy")]
        public static extern void unlink_all_proxy(IntPtr _command_);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_command_set_sync")]
        public static extern void set_sync(IntPtr _command_, Boolean _use_on_sync);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_command_see_history")]
        public static extern IntPtr see_history(IntPtr _command_, Address _proxy_addr, UIntPtr _history_size);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_command_set_history_size")]
        public static extern void set_history_size(IntPtr _command_, UIntPtr _history_size);

        [DllImport("64nerv35.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "nerv_stub_command_read")]
        public static extern Int32 read(IntPtr _command_, Address _proxy_addr, IntPtr _cmd_data_, ref UInt32 _cmd_size_);
    }
}
