<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../xsl_util.xsl"/>

<xsl:output method="text" encoding="utf-8" indent="yes"/>

<xsl:param name = "export_method_domain_path" />

<xsl:template match="/">
<xsl:for-each select="nerv_icde/methoddomain/row">
<xsl:if test="path=$export_method_domain_path">
<xsl:variable name="open_namespace_path">
<xsl:call-template name="replace">
  <xsl:with-param name="text" select="path" />
  <xsl:with-param name="replace" select="'/'" />
  <xsl:with-param name="by" select="' { namespace '" />
</xsl:call-template>
</xsl:variable>
<xsl:variable name="close_namespace_path">
<xsl:call-template name="replace">
  <xsl:with-param name="text" select="path" />
  <xsl:with-param name="replace" select="'/'" />
  <xsl:with-param name="by" select="' */ } /* '" />
</xsl:call-template>
</xsl:variable>
<xsl:variable name="define_path">
<xsl:call-template name="replace">
  <xsl:with-param name="text" select="path" />
  <xsl:with-param name="replace" select="'/'" />
  <xsl:with-param name="by" select="'__'" />
</xsl:call-template>
</xsl:variable>
/*******************************************************************************
    Document Header
    domain   : <xsl:value-of select="name"/>
    creator  : <xsl:value-of select="author"/>
    create date : <xsl:value-of select="create-day"/>
    description : <xsl:value-of select="description"/>
*******************************************************************************/
using System;
using System.Runtime.InteropServices;
using System.Collections.Concurrent;
using Nerv35;

namespace Nerv35 { namespace Method <xsl:value-of select="$open_namespace_path" /> {

// Standard Domain Port Constance
public static class Standard
{
    public const UInt16 port = <xsl:value-of select="standard_port"/>;
}

// Interface Defines
<xsl:for-each select="interface/row">
/*******************************************************************************
    Interface Name : <xsl:value-of select="name"/>
    Writer : <xsl:value-of select="../../author"/>
    Description : <xsl:value-of select="description"/>
*******************************************************************************/
// proxy
public interface IProxy_<xsl:value-of select="name"/> : Nerv35.IProxy<xsl:for-each select="membermethod/row">
, IProxy_method_<xsl:value-of select="method_name"/>
  </xsl:for-each>
{
}
public abstract class Proxy_<xsl:value-of select="name"/>
{
    public Nerv35.Proxy proxy;
  <xsl:for-each select="membermethod/row">
    public Proxy_method_<xsl:value-of select="method_name"/><xsl:text> </xsl:text><xsl:value-of select="method_name"/>;</xsl:for-each>

    public void alloc(IProxy_<xsl:value-of select="name"/> _interface)
    {
        proxy = new Nerv35.Proxy(_interface);
  <xsl:for-each select="membermethod/row"><xsl:text>
        </xsl:text><xsl:value-of select="method_name"/> = new Proxy_method_<xsl:value-of select="method_name"/>(ref proxy, _interface);</xsl:for-each>
    }
}

// stub
public interface IStub_<xsl:value-of select="name"/> : Nerv35.IStub<xsl:for-each select="membermethod/row">
, IStub_method_<xsl:value-of select="method_name"/>
  </xsl:for-each>
{
}
public abstract class Stub_<xsl:value-of select="name"/>
{
    public Nerv35.Stub stub;
  <xsl:for-each select="membermethod/row">
    public Stub_method_<xsl:value-of select="method_name"/><xsl:text> </xsl:text><xsl:value-of select="method_name"/>;</xsl:for-each>

    public void alloc(IStub_<xsl:value-of select="name"/> _interface)
    {
        stub = new Nerv35.Stub(_interface);
  <xsl:for-each select="membermethod/row"><xsl:text>
        </xsl:text><xsl:value-of select="method_name"/> = new Stub_method_<xsl:value-of select="method_name"/>(ref stub, _interface);</xsl:for-each>
    }
}
</xsl:for-each>

} } /* <xsl:value-of select="$close_namespace_path" /> */

</xsl:if>
</xsl:for-each>
</xsl:template>



</xsl:stylesheet>
