<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../xsl_util.xsl"/>

<xsl:output method="text" encoding="utf-8" indent="yes"/>

<xsl:param name = "export_proxy_class_id" />

<xsl:template match="/">
  <xsl:for-each select="/nerv_icde/component/proxy_list/row[id=$export_proxy_class_id]">
    <xsl:variable name="method_domain_id" select="method_domain_id" />
    <xsl:variable name="interface_name" select="interface_name" />
    <xsl:variable name="class_name" select="class_name" />

    <xsl:variable name="method_domain_path">
      <xsl:call-template name="get_method_domain_path">
        <xsl:with-param name="mathod_domain_id" select="$method_domain_id" />
      </xsl:call-template>
    </xsl:variable>

    <xsl:variable name="method_domain_namespace">
      <xsl:call-template name="replace">
        <xsl:with-param name="text" select="$method_domain_path" />
        <xsl:with-param name="replace" select="'/'" />
        <xsl:with-param name="by" select="'.'" />
      </xsl:call-template>
    </xsl:variable>
/*******************************************************************************
Document Header
component_name : <xsl:value-of select="../../name"/>
component_id : <xsl:value-of select="component_id"/>
method_domain_id : <xsl:value-of select="method_domain_id"/>
method_domain_name : Nerv35.Method<xsl:value-of select="$method_domain_namespace"/>
interface_name : Nerv35.Method<xsl:value-of select="$method_domain_namespace"/>.IProxy_<xsl:value-of select="interface_name"/>
class_name : <xsl:value-of select="class_name"/>
*******************************************************************************/
using System;
using Nerv35;
using Nerv35.Method<xsl:value-of select="$method_domain_namespace"/>;<xsl:text/>
    <xsl:for-each select="/nerv_icde/methoddomain/row">
      <xsl:if test="id=$method_domain_id">
        <xsl:for-each select="ref_data_domain/row">
          <xsl:variable name="data_domain_namespace">
            <xsl:call-template name="get_data_domain_namespace_cs">
              <xsl:with-param name="data_domain_id" select="data_domain_id" />
            </xsl:call-template>
          </xsl:variable>
using Nerv35.Data<xsl:value-of select="$data_domain_namespace"/>;
        </xsl:for-each>
      </xsl:if>
    </xsl:for-each>
    <!-- <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace_cs">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace_cs">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
          <xsl:if test="in_data != '(null)'"><xsl:text>
</xsl:text>using Nerv35.Data.<xsl:value-of select="substring($in_data_domain_namespace,2)"/>;</xsl:if>
          <xsl:if test="out_data != '(null)'"><xsl:text>
</xsl:text>using Nerv35.Data.<xsl:value-of select="substring($out_data_domain_namespace,2)"/>;</xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each> -->
public class <xsl:value-of select="$class_name"/>
    : Proxy_<xsl:value-of select="$interface_name"/>
    , IProxy_<xsl:value-of select="$interface_name"/>
{
    public <xsl:value-of select="$class_name"/>() { alloc(this); }

    void IProxy.on_connect()
    {
        Output.Log("<xsl:value-of select="$class_name"/>.IProxy.on_connect()");
    }
    void IProxy.on_disconnect()
    {
        Output.Log("<xsl:value-of select="$class_name"/>.IProxy.on_disconnect()");
    }
    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace_cs">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace_cs">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:if test="type!='CALL' and type!='SIGNAL'" >
    /***************************************************************************
    Method: <xsl:value-of select="name"/>
    Input: <xsl:if test="in_data != '(null)'"><xsl:value-of select="substring($in_data_domain_namespace,2)"/>.<xsl:value-of select="in_data"/></xsl:if>
    output: <xsl:if test="out_data != '(null)'"><xsl:value-of select="substring($out_data_domain_namespace,2)"/>.<xsl:value-of select="out_data"/></xsl:if>
    Method Type: <xsl:value-of select="type"/>
    Code: <xsl:value-of select="code"/>
    Description: <xsl:value-of select="description"/>
    ***************************************************************************/<xsl:text/>
            </xsl:if>
            <xsl:choose>
              <xsl:when test="type='EVENT'">
    void IProxy_method_<xsl:value-of select="$method_name"/>.on_unlink(Int32 _err)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IProxy_method_<xsl:value-of select="$method_name"/>.on_unlink("+
            "_err={0:D})",
            _err));
    }<xsl:text/>
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
    void IProxy_method_<xsl:value-of select="$method_name"/>.on_event(Double _elapsed_time)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IProxy_method_<xsl:value-of select="$method_name"/>.on_event("+
            "_elapsed_time={0:F})",
            _elapsed_time));
    }<xsl:text/>
                  </xsl:when>
                  <xsl:otherwise>
    void IProxy_method_<xsl:value-of select="$method_name"/>.on_event(
        ref <xsl:value-of select="out_data"/> _evt_data_,
        Double _elapsed_time)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IProxy_method_<xsl:value-of select="$method_name"/>.on_event("+
            "_elapsed_time={0:F})",
            _elapsed_time));
        _evt_data_.print("<xsl:value-of select="out_data"/>");
    }<xsl:text/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:when test="type='COMMAND'">
    void IProxy_method_<xsl:value-of select="$method_name"/>.on_unlink(Int32 _err)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IProxy_method_<xsl:value-of select="$method_name"/>.on_unlink("+
            "_err={0:D})",
            _err));
    }
              </xsl:when>
              <xsl:when test="type='INFORMATION'">
    void IProxy_method_<xsl:value-of select="$method_name"/>.on_unlink(Int32 _err)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IProxy_method_<xsl:value-of select="$method_name"/>.on_unlink("+
            "_err={0:D})",
            _err));
    }<xsl:text/>
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
    void IProxy_method_<xsl:value-of select="$method_name"/>.on_sync(
        Sync_model _sync_model,
        Double _packet_live_time,
        Double _packet_limit_time)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IProxy_method_<xsl:value-of select="$method_name"/>.on_sync("+
            "_sync_model={0:D}, live_time={0:F}, limit_time={0:F})",
            _sync_model, _packet_live_time, _packet_limit_time));
    }<xsl:text/>
                  </xsl:when>
                  <xsl:otherwise>
    void IProxy_method_<xsl:value-of select="$method_name"/>.on_sync(
        Sync_model _sync_model,
        Double _packet_live_time,
        Double _packet_limit_time,
        ref <xsl:value-of select="out_data"/> _inf_data_ )
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IProxy_method_<xsl:value-of select="$method_name"/>.on_sync("+
            "_sync_model={0:D}, live_time={0:F}, limit_time={0:F})",
            _sync_model, _packet_live_time, _packet_limit_time));
        _inf_data_.print("<xsl:value-of select="out_data"/>");
    }<xsl:text/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:when test="type='DATAGRAM'">
                <xsl:choose >
                  <xsl:when test="out_data='(null)'">
    void IProxy_method_<xsl:value-of select="$method_name"/>.on_datagram(
        Address _stub_addr,
        Double _elapsed_time)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IProxy_method_<xsl:value-of select="$method_name"/>.on_datagram("+
            "_stub_addr.ip={0:S}, _stub_addr.port={0:D}, _elapsed_time={0:F})",
            Util.inet_ntoa(_stub_addr.ip), _stub_addr.port, _elapsed_time));
    }<xsl:text/>
                  </xsl:when>
                  <xsl:otherwise>
    void IProxy_method_<xsl:value-of select="$method_name"/>.on_datagram(
        Address _stub_addr,
        ref <xsl:value-of select="out_data"/> _dtg_data_,
        Double _elapsed_time)
    {
        Output.Log(string.Format(
            "<xsl:value-of select="$class_name"/>."+
            "IProxy_method_<xsl:value-of select="$method_name"/>.on_datagram("+
            " _stub_addr.ip={0:S}, _stub_addr.port={0:D}, _elapsed_time={0:F})",
            Util.inet_ntoa(_stub_addr.ip), _stub_addr.port, _elapsed_time));
        _dtg_data_.print("<xsl:value-of select="out_data"/>");
    }<xsl:text/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
}<xsl:text/>
  </xsl:for-each>
</xsl:template>
</xsl:stylesheet>
