<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/><xsl:param name = "save_path" />
<xsl:param name = "xml_path" />
<!-- TODO : xalan 을 이용하는 배치파일을 만든다. 컴포넌트.xml + excute_xalan = 컴포넌트.bat = 헤더파일 + 소스파일 + cmake 파일 + 등등..... --><!-- xalan -o "c:\dev/ncgen.bat" -p save_path "'c:\dev'" "c:\dev\ai data.xml" "./xsl/excute_xalan.xsl" -->
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace"><xsl:with-param name="text" select="nerv_icde/component/name" /><xsl:with-param name="replace" select="' '" /><xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
<xsl:text/>#!/bin/bash -v

<xsl:for-each select="nerv_icde/datadomain/row">
mkdir -p "<xsl:value-of select="$save_path"/>/Nerv35/Data<xsl:value-of select="path"/>"<xsl:text/>
  <xsl:variable name="path" select="path"/>
  <xsl:for-each select="data/row">
xalan -o "<xsl:value-of select="$save_path"/>/Nerv35/Data<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.cs" -p export_data_domain_path "'<xsl:value-of select="$path"/>'" -p export_data_name "'<xsl:value-of select="name"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/Nerv35/XSL/CS/Nerv35/Data/data_domain_data_cs.xsl"<xsl:text/>
  </xsl:for-each>
</xsl:for-each>

<xsl:for-each select="nerv_icde/methoddomain/row">
mkdir -p "<xsl:value-of select="$save_path"/>/Nerv35/Method<xsl:value-of select="path"/>"
  <xsl:variable name="path" select="path"/>
  <xsl:for-each select="method/row">
xalan -o "<xsl:value-of select="$save_path"/>/Nerv35/Method<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.cs" -p export_method_domain_path "'<xsl:value-of select="$path"/>'" -p export_method_name "'<xsl:value-of select="name"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/Nerv35/XSL/CS/Nerv35/Method/method_domain_method_cs.xsl"<xsl:text/>
  </xsl:for-each>
xalan -o "<xsl:value-of select="$save_path"/>/Nerv35/Method<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.cs" -p export_method_domain_path "'<xsl:value-of select="$path"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/Nerv35/XSL/CS/Nerv35/Method/method_domain_cs.xsl"<xsl:text/>
</xsl:for-each>

<xsl:for-each select="nerv_icde/component/proxy_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/Nerv_Proxy/<xsl:value-of select="class_name"/>"
xalan -o "<xsl:value-of select="$save_path"/>/Nerv_Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cs" -p export_proxy_class_id "'<xsl:value-of select="id"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/Nerv35/XSL/CS/Nerv_Proxy/proxy_class_cs.xsl"
</xsl:for-each>
<xsl:for-each select="nerv_icde/component/stub_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/Nerv_Stub/<xsl:value-of select="class_name"/>"
xalan -o "<xsl:value-of select="$save_path"/>/Nerv_Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cs" -p export_stub_class_id "'<xsl:value-of select="id"/>'" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/Nerv35/XSL/CS/Nerv_Stub/stub_class_cs.xsl"
</xsl:for-each>

xalan -o "<xsl:value-of select="$save_path"/>/Nerv_component_<xsl:value-of select="/nerv_icde/component/name"/>.cs" "<xsl:value-of select="$xml_path"/>" "/usr/local/share/Nerv/Nerv35/XSL/CS/cs_nerv35_component.xsl"


</xsl:template>
</xsl:stylesheet>
