<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../xsl_util.xsl"/>

<xsl:output method="text" encoding="utf-8" indent="yes"/>

<xsl:template match="/">
    <xsl:variable name="component_name">
        <xsl:call-template name="replace">
            <xsl:with-param name="text" select="nerv_icde/component/name" />
            <xsl:with-param name="replace" select="' '" />
            <xsl:with-param name="by" select="'_'" />
        </xsl:call-template>
    </xsl:variable>
cmake_minimum_required(VERSION 2.6)
project("py_nerv35<!--xsl:value-of select="$component_name"/-->")

SET(CMAKE_BUILD_TYPE MinSizeRel)

FIND_PACKAGE(PythonInterp 3 REQUIRED)

if (PYTHONINTERP_FOUND)
    if (PYTHON_VERSION_MAJOR EQUAL 3)
        if(MSVC)
            # SET(Boost_INCLUDE_DIRS "c:/local/boost_1_73_0")
            # SET(Boost_LIBRARY_DIRS "c:/local/boost_1_73_0/lib64-msvc-14.2")
            SET(Boost_INCLUDE_DIRS "E:/Devtools/boost_1_72_0_msvc142_64")
            SET(Boost_LIBRARY_DIRS "E:/Devtools/boost_1_72_0_msvc142_64/lib64-msvc-14.2")
        else()
            FIND_PACKAGE(Boost COMPONENTS python-py36 REQUIRED)
        endif()
        FIND_PACKAGE(PythonInterp 3)
        FIND_PACKAGE(PythonLibs 3 REQUIRED)
    else()
        FIND_PACKAGE(Boost COMPONENTS python)
        FIND_PACKAGE(PythonInterp)
        FIND_PACKAGE(PythonLibs REQUIRED)
    endif()
endif()

MESSAGE(STATUS "PYTHON_LIBRARIES = ${PYTHON_LIBRARIES}")
MESSAGE(STATUS "PYTHON_EXECUTABLE = ${PYTHON_EXECUTABLE}")
MESSAGE(STATUS "PYTHON_INCLUDE_DIRS = ${PYTHON_INCLUDE_DIRS}")
MESSAGE(STATUS "Boost_LIBRARIES = ${Boost_LIBRARIES}")
MESSAGE(STATUS "Boost_INCLUDE_DIRS = ${Boost_INCLUDE_DIRS}")

# set library path environment variable
if (MSVC)
    SET(Nerv_INCLUDE_DIR "E:/Devtools/PortableGit/usr/local/share/Nerv/Nerv35/include")
    SET(Nerv_LIBRARY_DIR "E:/Devtools/PortableGit/usr/local/share/Nerv/Nerv35/lib")
    INCLUDE_DIRECTORIES( ../src/include ${CMAKE_SOURCE_DIR} ${Nerv_INCLUDE_DIR} ${Boost_INCLUDE_DIRS} ${PYTHON_INCLUDE_DIRS})
    LINK_DIRECTORIES( ${Nerv_LIBRARY_DIR} ${Boost_LIBRARY_DIRS})
	ADD_DEFINITIONS(-D_USRDLL)
	add_compile_options("/utf-8")
	add_compile_options("/std:c++17")
	add_compile_options("/bigobj")
	add_compile_options("/wd4267")
else()
    SET(Nerv_INCLUDE_DIR "/usr/local/share/Nerv/Nerv35/include")
    SET(Nerv_LIBRARY_DIR "/usr/local/share/Nerv/Nerv35/lib")
    INCLUDE_DIRECTORIES( ../src/include ${CMAKE_SOURCE_DIR} ${Nerv_INCLUDE_DIR} ${Boost_INCLUDE_DIRS} ${PYTHON_INCLUDE_DIRS})
    LINK_DIRECTORIES( ${Nerv_LIBRARY_DIR} )
    add_compile_options("-std=c++17")
	add_compile_options("-fPIC")
endif()

# set output directory
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/../..)
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/../..)
SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/../..)

# output setting
# ADD_EXECUTABLE (${PROJECT_NAME} ${CMAKE_SOURCE_DIR}/../src/py_nerv.cpp
ADD_LIBRARY(${PROJECT_NAME} SHARED ${CMAKE_SOURCE_DIR}/../src/py_nerv.cpp
<xsl:for-each select="/nerv_icde/component/proxy_list/row">${CMAKE_SOURCE_DIR}/../src/Nerv/Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cpp </xsl:for-each>
<xsl:for-each select="/nerv_icde/component/stub_list/row">${CMAKE_SOURCE_DIR}/../src/Nerv/Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cpp </xsl:for-each>)

# link library
if(MSVC)
    TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${PYTHON_LIBRARIES} 64nerv35)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES SUFFIX ".pyd")
else()
    TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${Boost_LIBRARIES} ${PYTHON_LIBRARIES} 64nerv35)
    SET_TARGET_PROPERTIES(${PROJECT_NAME} PROPERTIES PREFIX "")
endif()
</xsl:template>

</xsl:stylesheet>
