<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes" />
<xsl:template match="/">
import sys
import numpy
import py_nerv35 as nerv

  <xsl:for-each select="/nerv_icde/datadomain/row/data/row">

def <xsl:value-of select="name"/>(data):
    <xsl:call-template name="print_data">
      <xsl:with-param name="tab" select="4" />
      <xsl:with-param name="right_var" select="'data'" />
      <xsl:with-param name="domain_id" select="../../id" />
      <xsl:with-param name="data_name" select="name" />
    </xsl:call-template>
  </xsl:for-each>

</xsl:template>





<xsl:template name="print_data">
  <xsl:param name="tab" />
  <xsl:param name="right_var" />
  <xsl:param name="domain_id" />
  <xsl:param name="data_name" />
  <xsl:for-each select="/nerv_icde/datadomain/row[id=$domain_id]">
    <xsl:for-each select="data/row[name=$data_name]">
      <xsl:choose>
        <xsl:when test="type='alias'">
          <xsl:call-template name="print_data">
            <xsl:with-param name="tab" select="$tab" />
            <xsl:with-param name="right_var" select="$right_var" />
            <xsl:with-param name="domain_id" select="real_domain_id" />
            <xsl:with-param name="data_name" select="real_data" />
          </xsl:call-template>
        </xsl:when>
        <xsl:when test="type='struct'"><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="$tab"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />.get_size()= " , <xsl:value-of select="$right_var" />.get_sizeof() )<xsl:text/>
          <xsl:for-each select="datafield/row">
            <xsl:choose>
              <xsl:when test="arraytype='NO'">
                <xsl:choose>
                  <xsl:when test="type='alias'">
                    <xsl:call-template name="print_data">
                      <xsl:with-param name="tab" select="$tab" />
                      <xsl:with-param name="right_var"><xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" /></xsl:with-param>
                      <xsl:with-param name="domain_id" select="real_domain_id" />
                      <xsl:with-param name="data_name" select="real_data" />
                    </xsl:call-template>
                  </xsl:when>
                  <xsl:when test="type='scaled8_t' or type='scaled16_t' or type='scaled32_t' or type='scaled64_t' or type='u_scaled8_t' or type='u_scaled16_t' or type='u_scaled32_t' or type='u_scaled64_t'"><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="$tab"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />.<xsl:value-of select="member_name"/>= " , <xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />)<xsl:text/>
                  </xsl:when>
                  <xsl:when test="type='char_t'"><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="$tab"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />.<xsl:value-of select="member_name"/>= %c" % <xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />)<xsl:text/>
                  </xsl:when>
                  <xsl:otherwise><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="$tab"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />.<xsl:value-of select="member_name"/>= " , <xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />)<xsl:text/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:when test="arraytype='FIX'"><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="($tab)"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />.<xsl:value-of select="member_name"/>=" , <xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />_memory(0) )<xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="($tab)"/></xsl:call-template>for i in range(1):
                <xsl:choose>
                  <xsl:when test="type='alias'">
                    <xsl:call-template name="print_data">
                      <xsl:with-param name="tab" select="($tab)+4" />
                      <xsl:with-param name="right_var"><xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" /></xsl:with-param>
                      <xsl:with-param name="domain_id" select="real_domain_id" />
                      <xsl:with-param name="data_name" select="real_data" />
                    </xsl:call-template>
                  </xsl:when>
                  <xsl:when test="type='scaled8_t' or type='scaled16_t' or type='scaled32_t' or type='scaled64_t' or type='u_scaled8_t' or type='u_scaled16_t' or type='u_scaled32_t' or type='u_scaled64_t'"><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="($tab)+4"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />.<xsl:value-of select="member_name"/>= " , <xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />_get_at(i))<xsl:text/>
                  </xsl:when>
                  <xsl:when test="type='char_t'"><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="($tab)+4"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />.<xsl:value-of select="member_name"/>= %c" % <xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />_get_at(i))<xsl:text/>
                  </xsl:when>
                  <xsl:otherwise><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="($tab)+4"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />.<xsl:value-of select="member_name"/>= " , <xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />_get_at(i))<xsl:text/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:when test="arraytype='VARIABLE'"><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="($tab)"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />.<xsl:value-of select="member_name"/>= " , <xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />_memory(0) )<xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="($tab)"/></xsl:call-template>for i in range(1): # <xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />_size():
                <xsl:choose>
                  <xsl:when test="type='alias'">
                    <xsl:call-template name="print_data">
                      <xsl:with-param name="tab" select="($tab)+4" />
                      <xsl:with-param name="right_var"><xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />_at(i)</xsl:with-param>
                      <xsl:with-param name="domain_id" select="real_domain_id" />
                      <xsl:with-param name="data_name" select="real_data" />
                    </xsl:call-template>
                  </xsl:when>
                  <xsl:when test="type='scaled8_t' or type='scaled16_t' or type='scaled32_t' or type='scaled64_t' or type='u_scaled8_t' or type='u_scaled16_t' or type='u_scaled32_t' or type='u_scaled64_t'"><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="($tab)+4"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />.<xsl:value-of select="member_name"/>= " , <xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />_get_at(i))<xsl:text/>
                  </xsl:when>
                  <xsl:when test="type='char_t'"><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="($tab)+4"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />.<xsl:value-of select="member_name"/>= %c" % <xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />_get_at(i))<xsl:text/>
                  </xsl:when>
                  <xsl:otherwise><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="($tab)+4"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />.<xsl:value-of select="member_name"/>= " , <xsl:value-of select="$right_var" />.<xsl:value-of select="member_name" />_get_at(i))<xsl:text/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:when>
        <xsl:when test="type='scaled8_t' or type='scaled16_t' or type='scaled32_t' or type='scaled64_t' or type='u_scaled8_t' or type='u_scaled16_t' or type='u_scaled32_t' or type='u_scaled64_t'"><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="$tab"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />= " , <xsl:value-of select="$right_var" />)
        </xsl:when>
        <xsl:when test="type='char_t'"><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="$tab"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />= %c" % <xsl:value-of select="$right_var" />)<xsl:text/>
        </xsl:when>
        <xsl:otherwise><xsl:text>
</xsl:text><xsl:call-template name="space"><xsl:with-param name="count" select="$tab"/></xsl:call-template>print( "<xsl:value-of select="$right_var" />= " , <xsl:value-of select="$right_var" />)<xsl:text/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>
  </xsl:for-each>
</xsl:template>



</xsl:stylesheet>
