<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/><xsl:param name = "save_path" />
<xsl:param name = "xml_path" />
<!-- TODO : xalan 을 이용하는 배치파일을 만든다. 컴포넌트.xml + excute_xalan = 컴포넌트.bat = 헤더파일 + 소스파일 + cmake 파일 + 등등..... --><!-- xalan -out "c:\dev/ncgen.bat" -p save_path "'c:\dev'" "c:\dev\ai data.xml" "./xsl/excute_xalan.xsl" -->
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
<xsl:text/>#!/bin/bash

<xsl:for-each select="nerv_icde/datadomain/row">
mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv35/src/include/Nerv35/Data<xsl:value-of select="path"/>"<xsl:text/>
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/src/include/Nerv35/Data<xsl:value-of select="path"/>/<xsl:value-of select="name"/>.h" -param export_data_domain_path "'<xsl:value-of select="path"/>'" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/src/include/Nerv35/Data/data_domain_h.xsl"<xsl:text/>
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/src/include/Nerv35/Data<xsl:value-of select="path"/>/<xsl:value-of select="name"/>_export.h" -param export_data_domain_path "'<xsl:value-of select="path"/>'" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/src/include/Nerv35/Data/data_domain_export_h.xsl"<xsl:text/>
  <xsl:variable name="path" select="path"/>
  <xsl:for-each select="data/row">
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/src/include/Nerv35/Data<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.h" -param export_data_domain_path "'<xsl:value-of select="$path"/>'" -param export_data_name "'<xsl:value-of select="name"/>'" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/src/include/Nerv35/Data/data_domain_data_h.xsl"<xsl:text/>
  </xsl:for-each>
</xsl:for-each>

cp "/usr/local/share/Nerv/Nerv35/XSL/Python/src/include/Nerv35/Data/sizeof.h" "<xsl:value-of select="$save_path"/>/py_nerv35/src/include/Nerv35/Data/."

<xsl:for-each select="nerv_icde/methoddomain/row">
mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv35/src/include/Nerv35/Method<xsl:value-of select="path"/>"
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/src/include/Nerv35/Method<xsl:value-of select="path"/>/<xsl:value-of select="name"/>.h" -param export_method_domain_path "'<xsl:value-of select="path"/>'" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/src/include/Nerv35/Method/method_domain_h.xsl"
</xsl:for-each>

<xsl:for-each select="nerv_icde/component/proxy_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv35/src/Nerv/Proxy/<xsl:value-of select="class_name"/>"
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/src/Nerv/Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.h" -param export_proxy_class_id "'<xsl:value-of select="id"/>'" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/src/Nerv/Proxy/proxy_class_h.xsl"
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/src/Nerv/Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cpp" -param export_proxy_class_id "'<xsl:value-of select="id"/>'" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/src/Nerv/Proxy/proxy_class_cpp.xsl"
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/src/Nerv/Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>_export.h" -param export_proxy_class_id "'<xsl:value-of select="id"/>'" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/src/Nerv/Proxy/proxy_class_export_h.xsl"
</xsl:for-each>

<xsl:for-each select="nerv_icde/component/stub_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv35/src/Nerv/Stub/<xsl:value-of select="class_name"/>"
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/src/Nerv/Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.h" -param export_stub_class_id "'<xsl:value-of select="id"/>'" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/src/Nerv/Stub/stub_class_h.xsl"
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/src/Nerv/Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cpp" -param export_stub_class_id "'<xsl:value-of select="id"/>'" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/src/Nerv/Stub/stub_class_cpp.xsl"
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/src/Nerv/Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>_export.h" -param export_stub_class_id "'<xsl:value-of select="id"/>'" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/src/Nerv/Stub/stub_class_export_h.xsl"
</xsl:for-each>

xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/src/py_nerv.cpp" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/src/py_nerv_cpp.xsl"

mkdir -p "<xsl:value-of select="$save_path"/>/py_nerv35/build"
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/build/CMakeLists.txt" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/build/CMakeLists.xsl"
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35/build/cmake_clean" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/build/cmake_clean_sh.xsl"
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35_component.py" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/py_nerv35_component.xsl"
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35_print_data.py" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/py_nerv35_print_data.xsl"
xalan -out "<xsl:value-of select="$save_path"/>/py_nerv35_set_data.py" -in "<xsl:value-of select="$xml_path"/>" -xsl "/usr/local/share/Nerv/Nerv35/XSL/Python/py_nerv35_set_data.xsl"


</xsl:template>


</xsl:stylesheet>
