<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../../xsl_util.xsl"/>

<xsl:output method="text" encoding="utf-8" indent="yes"/>

<xsl:param name = "export_stub_class_id" />

<xsl:template match="/">
  <xsl:for-each select="/nerv_icde/component/stub_list/row[id=$export_stub_class_id]">
    <xsl:variable name="method_domain_id" select="method_domain_id" />
    <xsl:variable name="interface_name" select="interface_name" />
    <xsl:variable name="class_name" select="class_name" />

#include "<xsl:value-of select="$class_name"/>.h"
#include &lt;stdio.h&gt;

using namespace Nerv35;

<xsl:value-of select="$class_name"/>::<xsl:value-of select="$class_name"/>()
{
}

<xsl:value-of select="$class_name"/>::~<xsl:value-of select="$class_name"/>()
{
}


void <xsl:value-of select="$class_name"/>::on_connect(Nerv35::addr_t _proxy_addr)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_connect")(_proxy_addr);
    PyGILState_Release(state);
}

void <xsl:value-of select="$class_name"/>::on_disconnect(Nerv35::addr_t _proxy_addr)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_disconnect")(_proxy_addr);
    PyGILState_Release(state);
}


    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">

            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="type='CALL'">
                <xsl:choose>
                  <xsl:when test="in_data='(null)' and out_data='(null)'">
::Nerv35::nerv_err_t <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>( ::Nerv35::addr_t _proxy_addr, double _elapsed_time, double _limit_time)
{
    PyGILState_STATE state = PyGILState_Ensure();
    ::Nerv35::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>")(_proxy_addr, _elapsed_time, _limit_time);
    PyGILState_Release(state);
    return ret_err;
}
                  </xsl:when>
                  <xsl:when test="in_data='(null)' and out_data!='(null)'">
::Nerv35::nerv_err_t <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>(::Nerv35::addr_t _proxy_addr, Nerv35::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* p_out, double _elapsed_time, double _limit_time)
{
    PyGILState_STATE state = PyGILState_Ensure();
    ::Nerv35::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>")(_proxy_addr, p_out, _elapsed_time, _limit_time);
    PyGILState_Release(state);
    return ret_err;
}
                  </xsl:when>
                  <xsl:when test="in_data!='(null)' and out_data='(null)'">
::Nerv35::nerv_err_t <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>(::Nerv35::addr_t _proxy_addr, const Nerv35::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* p_in, double _elapsed_time, double _limit_time)
{
    PyGILState_STATE state = PyGILState_Ensure();
    ::Nerv35::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>")(_proxy_addr, p_in, _elapsed_time, _limit_time);
    PyGILState_Release(state);
    return ret_err;
}
                  </xsl:when>
                  <xsl:when test="in_data!='(null)' and out_data!='(null)'">
::Nerv35::nerv_err_t <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>( ::Nerv35::addr_t _proxy_addr, const Nerv35::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* p_in, <xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* p_out, double _elapsed_time, double _limit_time)
{
    PyGILState_STATE state = PyGILState_Ensure();
    ::Nerv35::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>")(_proxy_addr, p_in, p_out, _elapsed_time, _limit_time);
    PyGILState_Release(state);
    return ret_err;
}
                  </xsl:when>
                </xsl:choose>
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_cancel( ::Nerv35::addr_t _proxy_addr, ::Nerv35::nerv_err_t _error)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_cancel")(_proxy_addr, _error);
    PyGILState_Release(state);
}
              </xsl:when>
              <xsl:when test="type='SIGNAL'">
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>( addr_t _proxy_addr, const Nerv35::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _buf_, double _elapsed_time)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>")(_proxy_addr, _buf_, _elapsed_time);
    PyGILState_Release(state);
}

void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_cancel(addr_t _proxy_addr, nerv_err_t _error)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_cancel")(_proxy_addr, _error);
    PyGILState_Release(state);
}
              </xsl:when>
              <xsl:when test="type='EVENT'">
::Nerv35::nerv_err_t <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_link( ::Nerv35::addr_t _proxy_addr, double _packet_live_time, double _packet_limit_time)
{
    PyGILState_STATE state = PyGILState_Ensure();
    ::Nerv35::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>_link")(_proxy_addr, _packet_live_time, _packet_limit_time);
    PyGILState_Release(state);
    return ret_err;
}

void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_unlink(::Nerv35::addr_t _proxy_addr, nerv_err_t _err)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_unlink")(_proxy_addr,_err);
    PyGILState_Release(state);
}
              </xsl:when>
              <xsl:when test="type='COMMAND'">
::Nerv35::nerv_err_t <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_link(::Nerv35::addr_t _proxy_addr, double _packet_live_time, double _packet_limit_time)
{
    PyGILState_STATE state = PyGILState_Ensure();
    ::Nerv35::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>_link")(_proxy_addr, _packet_live_time, _packet_limit_time);
    PyGILState_Release(state);
    return ret_err;
}

void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_unlink(::Nerv35::addr_t _proxy_addr, nerv_err_t _err)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_unlink")(_proxy_addr,_err);
    PyGILState_Release(state);
}
                <xsl:choose >
                  <xsl:when test="in_data='(null)'">
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_sync(::Nerv35::addr_t _proxy_addr, Nerv35::Sync_model _sync_model, double _elapsed_time, double _limit_time)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_sync")(_proxy_addr, (Nerv35::uint8_t)_sync_model, _elapsed_time, _limit_time);
    PyGILState_Release(state);
}
                  </xsl:when>
                  <xsl:otherwise>
void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_sync(::Nerv35::addr_t _proxy_addr, Nerv35::Sync_model _sync_model, double _elapsed_time, double _limit_time, const Nerv35::Data<xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/>* _buffer_)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_sync")(_proxy_addr, (Nerv35::uint8_t)_sync_model, _elapsed_time, _limit_time, _buffer_);
    PyGILState_Release(state);
}
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:when test="type='INFORMATION'">
::Nerv35::nerv_err_t <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_link(::Nerv35::addr_t _proxy_addr, bool _reliability, double _packet_live_time, double _packet_limit_time)
{
    PyGILState_STATE state = PyGILState_Ensure();
    ::Nerv35::nerv_err_t ret_err = this->get_override("on_<xsl:value-of select="$method_name"/>_link")(_proxy_addr, _reliability, _packet_live_time, _packet_limit_time);
    PyGILState_Release(state);
    return ret_err;
}

void <xsl:value-of select="$class_name"/>::on_<xsl:value-of select="$method_name"/>_unlink(::Nerv35::addr_t _proxy_addr, nerv_err_t _err)
{
    PyGILState_STATE state = PyGILState_Ensure();
    this->get_override("on_<xsl:value-of select="$method_name"/>_unlink")(_proxy_addr, _err );
    PyGILState_Release(state);
}
              </xsl:when>
              <xsl:when test="type='DATAGRAM'">
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
</xsl:template>

</xsl:stylesheet>





