<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">



<xsl:template name="replace">
  <xsl:param name="text" />
  <xsl:param name="replace" />
  <xsl:param name="by" />
  <xsl:choose>
    <xsl:when test="contains($text, $replace)">
      <xsl:value-of select="substring-before($text,$replace)" />
      <xsl:value-of select="$by" />
      <xsl:call-template name="replace">
      <xsl:with-param name="text" select="substring-after($text,$replace)" />
      <xsl:with-param name="replace" select="$replace" />
      <xsl:with-param name="by" select="$by" />
      </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
      <xsl:value-of select="$text" />
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template name="get_data_domain_namespace">
  <xsl:param name="data_domain_id" />
  <xsl:for-each select="/nerv_icde/datadomain/row">
    <xsl:if test="id=$data_domain_id">
      <xsl:variable name="namespace">
        <xsl:call-template name="replace">
          <xsl:with-param name="text" select="path" />
          <xsl:with-param name="replace" select="'/'" />
          <xsl:with-param name="by" select="'::'" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:value-of select="$namespace" />
    </xsl:if>
  </xsl:for-each>
</xsl:template>

<xsl:template name="get_data_domain_namespace_cs">
  <xsl:param name="data_domain_id" />
  <xsl:for-each select="/nerv_icde/datadomain/row">
    <xsl:if test="id=$data_domain_id">
      <xsl:variable name="namespace">
        <xsl:call-template name="replace">
          <xsl:with-param name="text" select="path" />
          <xsl:with-param name="replace" select="'/'" />
          <xsl:with-param name="by" select="'.'" />
        </xsl:call-template>
      </xsl:variable>
      <xsl:value-of select="$namespace" />
    </xsl:if>
  </xsl:for-each>
</xsl:template>


<xsl:template name="get_original_type">
  <xsl:param name="data_domain_id" />
  <xsl:param name="data" />
  <xsl:for-each select="/nerv_icde/datadomain/row[id=$data_domain_id]">
    <xsl:for-each select="data/row[name=$data]">
      <xsl:if test="type!='alias'">
        <xsl:value-of select="type" />
      </xsl:if>
      <xsl:if test="type!='alias'">
        <xsl:call-template name="get_original_type">
          <xsl:with-param name="data_domain_id" select="real_domain_id" />
          <xsl:with-param name="data" select="real_data" />
        </xsl:call-template>
      </xsl:if>
    </xsl:for-each>
  </xsl:for-each>
</xsl:template>


<xsl:template name="get_method_domain_namespace">
  <xsl:param name="method_domain_id" />
  <xsl:for-each select="/nerv_icde/methoddomain/row">
  <xsl:if test="id=$method_domain_id">
    <xsl:variable name="namespace">
    <xsl:call-template name="replace">
     <xsl:with-param name="text" select="path" />
     <xsl:with-param name="replace" select="'/'" />
     <xsl:with-param name="by" select="'::'" />
    </xsl:call-template>
    </xsl:variable>
    <xsl:value-of select="$namespace" />
  </xsl:if>
  </xsl:for-each>
</xsl:template>



<xsl:template name="get_method_domain_path">
  <xsl:param name="mathod_domain_id" />
  <xsl:for-each select="/nerv_icde/methoddomain/row">
    <xsl:if test="id=$mathod_domain_id">
      <xsl:value-of select="path" />
    </xsl:if>
  </xsl:for-each>
</xsl:template>


<xsl:template name="space">
  <xsl:param name="count" />
  <xsl:if test="$count &gt; 0">
    <xsl:text><![CDATA[ ]]></xsl:text>
    <xsl:call-template name="space">
      <xsl:with-param name="count" select="($count)-1"/>
    </xsl:call-template>
  </xsl:if>
</xsl:template>



</xsl:stylesheet>