#pragma once

#include "nerv_define.h"
#include "nerv_typedef.hh"
#include <Nerv35/nerv_error.hh>

namespace Nerv35 {

class NERV_SDK_DLL Proxy {
	friend class Nerv_processor;
	friend class _Proxy;

public:
	Proxy();
	Proxy(const Proxy& __proxy_object);
	virtual ~Proxy();
	nerv_err_t start(addr_t _stub_addr);
	nerv_err_t stop();
	bool       is_connected();
	bool       is_started();
	nerv_err_t get_address(addr_t* _proxy_addr_, addr_t* _stub_addr_);

protected:
	virtual void on_connect();
	virtual void on_disconnect();

protected:
	_Proxy* _pp;
};

} // namespace Nerv35
