#pragma once

#include "Proxy.hh"
#include <Nerv35/nerv_history.hh>

namespace Nerv35 {

class NERV_SDK_DLL Proxy_command
    : virtual public Proxy {
	friend class _Proxy_command;
	friend class _Proxy;
public:
	Proxy_command(msg_code_t _code);
	Proxy_command(msg_code_t               _code,
	                          const Proxy& __proxy_object);
	virtual ~Proxy_command();

	bool                   is_linked();
	const return_promise_t async_link(double _limit_time = 1.0);
	nerv_err_t async_link_return(return_promise_t ret_promise, double* _time_);
	void       unlink();
	void       set_sync_model(bool       _reliability,
	                          Sync_model _sync_model,
	                          double     _interval);
	void*      get(pksize_t _size);
	void       cancel();
	nerv_err_t post(pksize_t _size);
	nerv_err_t write(const void* _data_, pksize_t _size);
	letter_case_t see_history(size_t _size);
	void          set_history_size(size_t _history_size);
	nerv_err_t    read(void* _data_, pksize_t* _size_);

protected:
	virtual void on_unlink(nerv_err_t _err);

protected:
	_Proxy_command* _mp;
};

} // namespace Nerv35
