#pragma once

#include "Proxy.hh"

namespace Nerv35 {

class NERV_SDK_DLL Proxy_event : virtual public Proxy {
	friend class _Proxy_event;

public:
	Proxy_event(msg_code_t _code);
	Proxy_event(msg_code_t               _code,
	                        const Proxy& __proxy_object);
	virtual ~Proxy_event();
	bool                   is_linked();
	const return_promise_t async_link(double _limit_time = 1.0);
	nerv_err_t async_link_return(return_promise_t ret_promise, double* _time_);
	void       unlink();

private:
	virtual void on_unlink(nerv_err_t _err);
	virtual void on_event(const void* _event_data_,
	                      pksize_t    _event_size,
	                      double      _elapsed_time);

private:
	_Proxy_event* _mp;
};

} // namespace Nerv35
