#pragma once

#include "Proxy.hh"
#include <Nerv35/nerv_history.hh>

namespace Nerv35 {

class NERV_SDK_DLL Proxy_information
    : virtual public Proxy {
	friend class _Proxy_information;

public:
	Proxy_information(msg_code_t _code);
	Proxy_information(msg_code_t               _code,
	                              const Proxy& __proxy_object);
	virtual ~Proxy_information(void);
	bool                   is_linked();
	const return_promise_t async_link(bool   _reliability = false,
	                                  double _limit_time = 1.0);
	nerv_err_t async_link_return(return_promise_t ret_promise, double* _time_);
	void       unlink();
	void       set_sync(bool _use_on_sync);
	letter_case_t see_history(size_t _size);
	void          set_history_size(size_t _history_size);
	nerv_err_t    read(void* _data_, pksize_t* _size_);

private:
	virtual void on_unlink(nerv_err_t _err);
	virtual void on_sync(Sync_model  _sync_model,
	                     double      _elapsed_time,
	                     double      _limit,
	                     const void* _buffer_,
	                     pksize_t    _size);

private:
	_Proxy_information* _mp;
};

} // namespace Nerv35
