#pragma once

#include "nerv_define.h"
#include "nerv_typedef.hh"
#include <Nerv35/nerv_error.hh>
#include <shared_mutex>

namespace Nerv35 {
class NERV_SDK_DLL Stub {

	friend class Nerv_processor;
	friend class _Stub;

public:
	Stub();
	virtual ~Stub();
	nerv_err_t start(const char* _name_, port_t* _port_);
	nerv_err_t start_for_python(const char* _name_, int _port_);
	nerv_err_t stop();
	bool       is_started();

protected:
	virtual void on_connect(addr_t _proxy_addr);
	virtual void on_disconnect(addr_t _proxy_addr);

protected:
	_Stub* _op;
};
} // namespace Nerv35
