#pragma once

#include "nerv_error.hh"
#include "Stub.hh"

namespace Nerv35 {
class NERV_SDK_DLL Stub_call : virtual public Stub {
	friend class _Stub_call;

public:
	Stub_call(msg_code_t _code, pksize_t _max_return_size);
	Stub_call(msg_code_t         _code,
	                 pksize_t           _max_return_size,
	                 const Stub& __Stub);

	virtual ~Stub_call(void);

private:
	virtual nerv_err_t on_call(addr_t _proxy_addr,
	                           const void* _in_buf_,
	                           pksize_t    _in_buf_size,
	                           void*       _out_buf_,
	                           pksize_t*   _out_buf_size_,
	                           double      _elapsed_time,
	                           double      _packet_limit_time);
	virtual void on_call_cancel(addr_t _proxy_addr, nerv_err_t _error);

private:
	_Stub_call* _mp;
};
} // namespace Nerv35
