#pragma once

#include "Stub.hh"
#include <Nerv35/nerv_history.hh>

namespace Nerv35 {

class NERV_SDK_DLL Stub_command : public virtual Stub {
	friend class _Stub_command;

public:
	Stub_command(msg_code_t _code);
	Stub_command(msg_code_t _code, const Stub& __Stub);
	virtual ~Stub_command();
	void          unlink(addr_t _proxy_addr);
	void          unlink_all_proxy();
	void          set_sync(bool _use_on_sync);
	letter_case_t see_history(addr_t _proxy_addr, size_t _size);
	void          set_history_size(size_t _history_size);
	nerv_err_t    read(addr_t _proxy_addr, void* _data_, pksize_t* _size_);

private:
	virtual void       on_sync(addr_t _proxy_addr,
	                           Sync_model  _sync_model,
	                           double      _elapsed_time,
	                           double      _limit,
	                           const void* _buffer_,
	                           pksize_t    _size);
	virtual nerv_err_t on_link(addr_t _proxy_addr,
	                           double      _packet_live_time,
	                           double      _packet_limit_time);
	virtual void       on_unlink(addr_t _proxy_addr, nerv_err_t _err);

private:
	_Stub_command* _mp;
};

} // namespace Nerv35
