#pragma once

#include "Stub.hh"
#include <Nerv35/nerv_error.hh>

namespace Nerv35 {
class NERV_SDK_DLL Stub_event : virtual public Stub {
	friend class _Stub_event;

public:
	Stub_event(msg_code_t _code);
	Stub_event(msg_code_t _code, const Stub& __Stub);
	virtual ~Stub_event();
	void       unlink_all_proxy();
	void       unlink(addr_t _proxy_addr);
	nerv_err_t event(const void* _buffer_, pksize_t _size);
	nerv_err_t event();

private:
	virtual nerv_err_t on_link(addr_t _proxy_addr,
	                           double      _packet_live_time,
	                           double      _packet_limit_time);
	virtual void       on_unlink(addr_t _proxy_addr, nerv_err_t _err);

private:
	_Stub_event* _mp;
};
} // namespace Nerv35
