#pragma once

#include "Stub.hh"
#include <Nerv35/nerv_history.hh>

namespace Nerv35 {
class NERV_SDK_DLL Stub_information : virtual public Stub {
	friend class _Stub_information;

public:
	Stub_information(msg_code_t _code);
	Stub_information(msg_code_t _code, const Stub& __Stub);
	virtual ~Stub_information(void);
	void          set_sync_model(Sync_model _sync_model, double _interval);
	void          unlink(addr_t _proxy_addr);
	void          unlink_all_proxy();
	void*         get(pksize_t _size);
	void          cancel();
	nerv_err_t    post(pksize_t _size);
	nerv_err_t    write(const void* _data_, pksize_t _size);
	letter_case_t see_history(size_t _size);
	void          set_history_size(size_t _history_size);
	nerv_err_t    read(void* _data_, pksize_t* _size_);

private:
	virtual nerv_err_t on_link(addr_t _proxy_addr,
	                           bool        _reliability,
	                           double      _packet_live_time,
	                           double      _packet_limit_time);
	virtual void       on_unlink(addr_t _proxy_addr, nerv_err_t _err);

private:
	_Stub_information* _mp;
};
} // namespace Nerv35
