#pragma once

#include "nerv_error.hh"
#include "Stub.hh"

namespace Nerv35 {
typedef nerv_err_t on_signal_sync_t(Stub_signal* _this_,
                                    addr_t         _proxy_addr,
                                    void* const         _buf_,
                                    pksize_t            _buf_size,
                                    double              _elapsed_time,
                                    double              _packet_limit_time);

class NERV_SDK_DLL Stub_signal : virtual public Stub {
	friend class _Stub_signal;

public:
	Stub_signal(msg_code_t _code);
	Stub_signal(msg_code_t         _code,
	                   const Stub& __Stub,
	                   on_signal_sync_t*  _on_signal_sync__);
	virtual ~Stub_signal(void);

private:
	virtual void on_signal(addr_t _proxy_addr,
	                       const void* _buf_,
	                       pksize_t    _buf_size,
	                       double      _elapsed_time);
	virtual void on_signal_cancel(addr_t _proxy_addr, nerv_err_t _error);

private:
	_Stub_signal* _mp;
};
} // namespace Nerv35
