#pragma once

#include "nerv_define.h"
#include "nerv_typedef.hh"


namespace Nerv35 {

typedef uint8_t transaction_t;

constexpr transaction_t NERV_TRANSACTION_OBJECT_ = 0U;
constexpr transaction_t NERV_TRANSACTION_CALL_ = 1U;
constexpr transaction_t NERV_TRANSACTION_SIGNAL_ = 2U;
constexpr transaction_t NERV_TRANSACTION_EVENT_ = 3U;
constexpr transaction_t NERV_TRANSACTION_COMMAND_ = 4U;
constexpr transaction_t NERV_TRANSACTION_INFORMATION_ = 5U;
constexpr transaction_t NERV_TRANSACTION_DATAGRAM_ = 6U;

typedef struct struct_message_address {
	port_t        port;
	msg_code_t    code;
	transaction_t transaction;
} msg_addr_t;

inline bool operator<(msg_addr_t _left, msg_addr_t _right)
{
	return (_left.port < _right.port) ||
	       (_left.port == _right.port && _left.code < _right.code) ||
	       (_left.port == _right.port && _left.code == _right.code &&
	        _left.transaction < _right.transaction);
}

NERV_SDK_DLL void msg_processing_by_serial_group(msg_addr_t _a, msg_addr_t _b);
NERV_SDK_DLL void msg_processing_by_serial_alone(msg_addr_t _a);
NERV_SDK_DLL void msg_processing_by_parallel(msg_addr_t _a);

} // namespace Nerv35
