#pragma once

#include "nerv_define.h"
#include "nerv_pre_define.hh"
#include <stddef.h>
#include <stdint.h>

namespace Nerv35 {

typedef ::uint8_t  char_t;   // size : 1

typedef ::int8_t   int8_t;   // size : 1
typedef ::int16_t  int16_t;  // size : 2
typedef ::int32_t  int32_t;  // size : 4
typedef ::int64_t  int64_t;  // size : 8
typedef ::uint8_t  uint8_t;  // size : 1
typedef ::uint16_t uint16_t; // size : 2
typedef ::uint32_t uint32_t; // size : 4
typedef ::uint64_t uint64_t; // size : 8
typedef uint8_t    enum8_t;
typedef uint16_t   enum16_t;
typedef uint32_t   enum32_t;
typedef uint64_t   enum64_t;
typedef ::size_t   size_t; /* 데이터 크기    */

#if defined _MSC_VER || defined __GNUC__
typedef float                   float32_t;
typedef double                  float64_t;
#endif

#if defined           _MSC_VER
typedef unsigned long ip_t; /* IP add_ress     */
#else
typedef uint32_t ip_t; /* IP add_ress     */
#endif

typedef uint16_t               msg_code_t; /* 메시지 코드    */
typedef uint16_t               port_t;     /* Domain add_ress */
typedef uint32_t               pksize_t;   /* 데이터 크기    */
typedef uint64_t               nerv_clock_t;
typedef struct_return_promise* return_promise_t;

typedef struct addr_t {
	ip_t   ip;
	port_t port;
	addr_t() : ip(0U), port(0U) {}
	addr_t(ip_t _ip, port_t _port) : ip(_ip), port(_port) {}
} struct_nerv_addr;

inline bool operator<(addr_t _left, addr_t _right)
{
	return (_left.port < _right.port ||
	        (_left.port == _right.port && _left.ip < _right.ip));
}

enum class Sync_model : uint8_t { on_post = 0x00U, on_timer = 0x01U };

/* 가변 필드용 제어 구조체 */
typedef struct struct_variable_array_field_dctrl {
	pksize_t dindex; // byte 단위의 저장 인덱스 위치
	pksize_t dsize;  // byte 단위의 size 저장
} variable_array_field_dctrl_t;

} // namespace Nerv35
